(define_conditions [
  (-1 "TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, false, SImode)")
  (-1 "aarch64_zero_extend_const_eq (DImode, operands[3],
                                 SImode, operands[2])")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[1], V2SImode))")
  (-1 "!HONOR_SIGNED_ZEROS (DFmode) && TARGET_FLOAT")
  (-1 "TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2DFmode)))")
  (-1 "UINTVAL (operands[3]) < GET_MODE_BITSIZE (SImode)
   && (UINTVAL (operands[3]) + UINTVAL (operands[4])
       == GET_MODE_BITSIZE (SImode))")
  (-1 "reload_completed && FP_REGNUM_P (REGNO (operands[0]))")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, true, DImode)")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (DFmode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (DFmode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (SFmode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "aarch64_is_extend_from_extract (SImode, operands[2], operands[3])")
  (-1 "TARGET_SIMD && aarch64_operands_ok_for_ldpstp (operands, false, V4HImode)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, false, SImode)")
  (-1 "(TARGET_SIMD) && (TARGET_SIMD_F16INST)")
  (-1 "(TARGET_FLOAT && aarch64_nopcrelative_literal_loads) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "(register_operand (operands[0], QImode)
    || aarch64_reg_or_zero (operands[1], QImode))")
  (-1 "UINTVAL (operands[2]) < 64")
  (-1 "ptr_mode == DImode")
  (-1 "TARGET_SIMD_RDMA")
  (-1 "(TARGET_FLOAT && aarch64_nopcrelative_literal_loads) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "TARGET_FLOAT && (register_operand (operands[0], DFmode)
    || aarch64_reg_or_fp_zero (operands[1], DFmode))")
  (-1 "TARGET_FLOAT && (reload_completed || reload_in_progress)")
  (-1 "UINTVAL (operands[3]) < GET_MODE_BITSIZE (DImode) &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == GET_MODE_BITSIZE (DImode))")
  (-1 "UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, V4HImode)")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, false, DImode)")
  (-1 "rtx_equal_p (XEXP (operands[2], 0),
		plus_constant (Pmode,
			       XEXP (operands[0], 0),
			       GET_MODE_SIZE (DFmode)))")
  (-1 "(register_operand (operands[0], TImode)
    || aarch64_reg_or_zero (operands[1], TImode))")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))")
  (-1 "UINTVAL (operands[1]) < GET_MODE_BITSIZE (SImode)
   && UINTVAL (operands[1]) % 16 == 0")
  (-1 "rtx_equal_p (XEXP (operands[3], 0),
		plus_constant (Pmode,
			       XEXP (operands[1], 0),
			       GET_MODE_SIZE (DImode)))")
  (-1 "TARGET_SIMD && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))")
  (-1 "ptr_mode == SImode")
  (-1 "TARGET_SIMD && aarch64_operands_ok_for_ldpstp (operands, false, V2SFmode)")
  (-1 "UINTVAL (operands[1]) <= 32")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[2], 0),
		   plus_constant (Pmode,
				  XEXP (operands[0], 0),
				  GET_MODE_SIZE (V2SFmode)))")
  (-1 "rtx_equal_p (XEXP (operands[3], 0),
		plus_constant (Pmode,
			       XEXP (operands[1], 0),
			       GET_MODE_SIZE (SImode)))")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))")
  (-1 "(register_operand (operands[0], HImode)
    || aarch64_reg_or_zero (operands[1], HImode))")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (SFmode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "UINTVAL (operands[1]) <= 16")
  (-1 "TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))")
  (-1 "aarch64_zero_extend_const_eq (DImode, operands[2],
				 SImode, operands[1])")
  (-1 "aarch64_mask_and_shift_for_ubfiz_p (SImode, operands[3], operands[2])")
  (-1 "TARGET_ILP32")
  (-1 "(TARGET_FLOAT) && (AARCH64_ISA_F16)")
  (-1 "!(UINTVAL (operands[1]) == 0
     || (UINTVAL (operands[2]) + UINTVAL (operands[1])
	 > GET_MODE_BITSIZE (SImode)))")
  (-1 "ptr_mode == SImode || Pmode == SImode")
  (-1 "rtx_equal_p (XEXP (operands[3], 0),
		plus_constant (Pmode,
			       XEXP (operands[1], 0),
			       GET_MODE_SIZE (SFmode)))")
  (-1 "INTVAL (operands[1]) > 0
   && ((INTVAL (operands[1]) + INTVAL (operands[2]))
	<= GET_MODE_BITSIZE (SImode))
   && aarch64_bitmask_imm (
	UINTVAL (aarch64_mask_from_zextract_ops (operands[1],
						 operands[2])),
	SImode)")
  (-1 "reload_completed && aarch64_split_128bit_move_p (operands[0], operands[1])")
  (-1 "aarch64_is_extend_from_extract (DImode, operands[2], operands[3])")
  (1 "ptr_mode == DImode || Pmode == DImode")
  (-1 "aarch64_move_imm (INTVAL (operands[2]), DImode)")
  (-1 "GET_CODE (operands[1]) == SYMBOL_REF
   && !aarch64_is_long_call_p (operands[1])
   && !aarch64_is_noplt_call_p (operands[1])")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))")
  (-1 "TARGET_SIMD && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))")
  (-1 "UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (DFmode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "((!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && (ptr_mode == DImode || Pmode == DImode)) && ( true)")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)")
  (-1 "(TARGET_SIMD) && ( reload_completed)")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (SFmode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "TARGET_FLOAT")
  (-1 "TARGET_SIMD && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))")
  (-1 "(TARGET_SIMD) && (AARCH64_ISA_F16)")
  (-1 "(register_operand (operands[0], DImode)
    || aarch64_reg_or_zero (operands[1], DImode))")
  (-1 "TARGET_SIMD && !BYTES_BIG_ENDIAN")
  (-1 "UINTVAL (operands[1]) <= 8")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, false, SFmode)")
  (-1 "TARGET_CRC32")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, false, DFmode)")
  (-1 "aarch64_use_return_insn_p ()")
  (-1 "(register_operand (operands[0], SImode)
    || aarch64_reg_or_zero (operands[1], SImode))")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, SImode)")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (SImode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed")
  (-1 "TARGET_SIMD")
  (-1 "aarch64_zero_extend_const_eq (TImode, operands[2],
				 DImode, operands[1])")
  (-1 "TARGET_FP_F16INST")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[2], 0),
		   plus_constant (Pmode,
				  XEXP (operands[0], 0),
				  GET_MODE_SIZE (V2SImode)))")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, false, SFmode)")
  (-1 "reload_completed")
  (-1 "UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)")
  (-1 "TARGET_SIMD && reload_completed")
  (-1 "aarch_rev16_shleft_mask_imm_p (operands[3], DImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], DImode)")
  (-1 "epilogue_completed")
  (-1 "INTVAL (operands[1]) > 0
   && ((INTVAL (operands[1]) + INTVAL (operands[2]))
	<= GET_MODE_BITSIZE (DImode))
   && aarch64_bitmask_imm (
	UINTVAL (aarch64_mask_from_zextract_ops (operands[1],
						 operands[2])),
	DImode)")
  (-1 "TARGET_FLOAT && (register_operand (operands[0], TFmode)
    || aarch64_reg_or_fp_zero (operands[1], TFmode))")
  (-1 "(TARGET_LSE) && ( reload_completed)")
  (-1 "rtx_equal_p (XEXP (operands[2], 0),
		plus_constant (Pmode,
			       XEXP (operands[0], 0),
			       GET_MODE_SIZE (SFmode)))")
  (-1 " reload_completed")
  (-1 "TARGET_SIMD && reload_completed
   && GP_REGNUM_P (REGNO (operands[0]))
   && GP_REGNUM_P (REGNO (operands[1]))")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (DImode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, V4HFmode)")
  (-1 "UINTVAL (operands[3]) < GET_MODE_BITSIZE (SImode) &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == GET_MODE_BITSIZE (SImode))")
  (-1 "aarch64_mask_and_shift_for_ubfiz_p (DImode, operands[3], operands[2])")
  (-1 "TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2SFmode)))")
  (-1 "TARGET_FLOAT && TARGET_SIMD")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[2], 0),
		   plus_constant (Pmode,
				  XEXP (operands[0], 0),
				  GET_MODE_SIZE (V4HFmode)))")
  (-1 "SIBLING_CALL_P (insn)")
  (-1 "rtx_equal_p (XEXP (operands[2], 0),
		plus_constant (Pmode,
			       XEXP (operands[0], 0),
			       GET_MODE_SIZE (DImode)))")
  (-1 "(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "TARGET_SIMD && aarch64_operands_ok_for_ldpstp (operands, false, V8QImode)")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, true, SFmode)")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (DImode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[2], 0),
		   plus_constant (Pmode,
				  XEXP (operands[0], 0),
				  GET_MODE_SIZE (V4HImode)))")
  (-1 "TARGET_SIMD && aarch64_operands_ok_for_ldpstp (operands, false, V2SImode)")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))")
  (-1 "((!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && (ptr_mode == SImode || Pmode == SImode)) && ( true)")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (SFmode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[3], 0),
		   plus_constant (Pmode,
				  XEXP (operands[1], 0),
				  GET_MODE_SIZE (V4HImode)))")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (DFmode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "aarch64_uxt_size (exact_log2 (INTVAL (operands[2])),INTVAL (operands[3])) != 0")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (DImode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, true, DFmode)")
  (-1 "!(UINTVAL (operands[1]) == 0
     || (UINTVAL (operands[3]) + UINTVAL (operands[1])
	 > GET_MODE_BITSIZE (SImode)))")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (DImode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "TARGET_SIMD && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], CImode)
       || register_operand (operands[1], CImode))")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (SImode)) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "aarch64_zero_extend_const_eq (TImode, operands[3],
                                 DImode, operands[2])")
  (-1 "(TARGET_TLS_DESC) && (ptr_mode == SImode)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, V2SImode)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, false, DImode)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, DImode)")
  (-1 "(INTVAL (operands[5]) == INTVAL (operands[4]) + GET_MODE_SIZE (SImode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "TARGET_FLOAT && (register_operand (operands[0], SFmode)
    || aarch64_reg_or_fp_zero (operands[1], SFmode))")
  (-1 "(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "rtx_equal_p (XEXP (operands[3], 0),
		plus_constant (Pmode,
			       XEXP (operands[1], 0),
			       GET_MODE_SIZE (DFmode)))")
  (-1 "TARGET_LSE && reload_completed")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))")
  (-1 "TARGET_SIMD && BYTES_BIG_ENDIAN")
  (-1 "(INTVAL (operands[5]) == GET_MODE_SIZE (SImode)) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && ( true)")
  (-1 "(TARGET_TLS_DESC) && (ptr_mode == DImode)")
  (-1 "!(UINTVAL (operands[1]) == 0
     || (UINTVAL (operands[3]) + UINTVAL (operands[1])
	 > GET_MODE_BITSIZE (DImode)))")
  (-1 "aarch64_operands_adjust_ok_for_ldpstp (operands, false, DFmode)")
  (-1 "(CONST_INT_P (operands[1]) && !aarch64_move_imm (INTVAL (operands[1]), DImode))
    && REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0]))")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, SFmode)")
  (-1 "!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))")
  (-1 "TARGET_SIMD && reload_completed
   && ((FP_REGNUM_P (REGNO (operands[0])) && GP_REGNUM_P (REGNO (operands[1])))
       || (GP_REGNUM_P (REGNO (operands[0])) && FP_REGNUM_P (REGNO (operands[1]))))")
  (-1 "!(UINTVAL (operands[1]) == 0
     || (UINTVAL (operands[2]) + UINTVAL (operands[1])
	 > GET_MODE_BITSIZE (DImode)))")
  (-1 "TARGET_SIMD && aarch64_operands_ok_for_ldpstp (operands, false, V4HFmode)")
  (-1 "aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)")
  (-1 "optimize > 0 && flag_modulo_sched")
  (-1 "(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && (ptr_mode == SImode || Pmode == SImode)")
  (-1 "TARGET_SIMD && TARGET_CRYPTO")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[3], 0),
		   plus_constant (Pmode,
				  XEXP (operands[1], 0),
				  GET_MODE_SIZE (V2SImode)))")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))")
  (-1 "CONST_INT_P (operands[1]) && !aarch64_move_imm (INTVAL (operands[1]), SImode)
    && REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0]))")
  (-1 "((!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && (ptr_mode == DImode || Pmode == DImode)) && ( true)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, DFmode)")
  (-1 "GET_CODE (operands[0]) == SYMBOL_REF
   && !aarch64_is_long_call_p (operands[0])
   && !aarch64_is_noplt_call_p (operands[0])")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[2], 0),
		   plus_constant (Pmode,
				  XEXP (operands[0], 0),
				  GET_MODE_SIZE (V8QImode)))")
  (-1 "TARGET_SIMD && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))")
  (-1 "TARGET_LSE")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, V8QImode)")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[3], 0),
		   plus_constant (Pmode,
				  XEXP (operands[1], 0),
				  GET_MODE_SIZE (V8QImode)))")
  (-1 "TARGET_SIMD && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], CImode)
       || register_operand (operands[1], CImode))")
  (-1 "!STRICT_ALIGNMENT")
  (-1 "aarch64_uxt_size (exact_log2 (INTVAL (operands[2])), INTVAL (operands[3])) != 0")
  (-1 "TARGET_SIMD &&TARGET_CRYPTO")
  (-1 "(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && (ptr_mode == DImode || Pmode == DImode)")
  (-1 "aarch64_operands_ok_for_ldpstp (operands, true, V2SFmode)")
  (-1 "(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && ( true)")
  (-1 "UINTVAL (operands[3]) < GET_MODE_BITSIZE (DImode)
   && (UINTVAL (operands[3]) + UINTVAL (operands[4])
       == GET_MODE_BITSIZE (DImode))")
  (-1 "UINTVAL (operands[1]) < GET_MODE_BITSIZE (DImode)
   && UINTVAL (operands[1]) % 16 == 0")
  (-1 "UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)")
  (-1 "UINTVAL (operands[2]) < 32")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[3], 0),
		   plus_constant (Pmode,
				  XEXP (operands[1], 0),
				  GET_MODE_SIZE (V4HFmode)))")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))")
  (-1 "aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0")
  (-1 "TARGET_FLOAT && (register_operand (operands[0], HFmode)
    || aarch64_reg_or_fp_zero (operands[1], HFmode))")
  (-1 "rtx_equal_p (XEXP (operands[2], 0),
		plus_constant (Pmode,
			       XEXP (operands[0], 0),
			       GET_MODE_SIZE (SImode)))")
  (-1 "TARGET_FLOAT && !flag_rounding_math")
  (-1 "((!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && (ptr_mode == SImode || Pmode == SImode)) && ( true)")
  (-1 "TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V4SFmode)))")
  (-1 "!HONOR_SIGNED_ZEROS (SFmode) && TARGET_FLOAT")
  (-1 "aarch64_uxt_size (INTVAL (operands[2]),INTVAL (operands[3])) != 0")
  (-1 "TARGET_SIMD
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))")
  (-1 "TARGET_SIMD_F16INST")
  (-1 "UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)")
  (-1 "aarch64_move_imm (INTVAL (operands[2]), SImode)")
  (-1 "TARGET_SIMD
   && rtx_equal_p (XEXP (operands[3], 0),
		   plus_constant (Pmode,
				  XEXP (operands[1], 0),
				  GET_MODE_SIZE (V2SFmode)))")
  (-1 "!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed")
])
